var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result) __defProp(target, key, result);
  return result;
};

// src/index.ts
import { LitElement, html } from "lit";
import { customElement, property, state } from "lit/decorators.js";
import { map } from "lit/directives/map.js";
var Pagination = class extends LitElement {
  constructor() {
    super(...arguments);
    this.index = NaN;
    this.current = NaN;
    this.total = NaN;
    this.onChange = () => {
    };
    this.pages = [];
  }
  onClick(e) {
    const target = e.target;
    if (target?.tagName === "UI5-BUTTON") {
      const to = parseInt(target.dataset.to) || 0;
      if (this.renderRoot.dispatchEvent(
        new CustomEvent("page-to", {
          bubbles: true,
          composed: true,
          detail: to,
          cancelable: true
        })
      ))
        this.onChange?.(this.current = to);
    }
  }
  updated(changed) {
    if (changed.has("total"))
      this.pages = Array.from({ length: this.total }, (_, i) => i + 1);
    if (changed.has("index")) this.current || (this.current = this.index + 1 || 1);
    if (changed.has("current")) this.index || (this.index = this.current - 1 || 0);
    if (changed.has("index") && changed.has("current")) {
      if (this.current !== this.index + 1) {
        console.error("\u4E0D\u5408\u6CD5\u7684current\u6216index\u8F93\u5165");
        [this.index, this.current] = [0, 1];
      }
    }
  }
  render() {
    return html`<span
            style=" display: inline-flex;
            gap: 4px;"
            @click=${this.onClick}
        >
            <ui5-button
                design="Emphasized"
                icon="navigation-left-arrow"
                ?disabled="${!this.total || this.current == 1}"
                data-to=${this.current - 1}
            ></ui5-button>
            ${map(this.pages, (p) => {
      if (p === this.current)
        return html`<ui5-button design="Emphasized" disabled>
                        ${p}
                    </ui5-button>`;
      if (this.total < 8 || Math.abs(p - this.current) < Math.max(
        this.pages.at(5) - this.current,
        this.current - this.pages.at(-6),
        2
      ) || p == this.pages.at(1) && this.current == this.pages.at(3) || p == this.pages.at(-2) && this.current == this.pages.at(-4))
        return html` <ui5-button design="Default" data-to="${p}">
                        ${p}
                    </ui5-button>`;
      if (p === this.pages.at(0))
        return html`<ui5-button design="Default" data-to="1">
                        1
                    </ui5-button>`;
      if (p === this.pages.at(-1))
        return html`<ui5-button design="Default" data-to="${p}">
                        ${p}
                    </ui5-button>`;
      if (p === this.pages.at(1))
        return html`<ui5-button design="Transparent" disabled>
                        ...
                    </ui5-button>`;
      if (p === this.pages.at(-2))
        return html`<ui5-button design="Transparent" disabled>
                        ...
                    </ui5-button>`;
    })}
            <ui5-button
                design="Emphasized"
                icon="navigation-right-arrow"
                ?disabled="${!this.total || this.current == this.total}"
                data-to=${this.current + 1}
            ></ui5-button>
        </span>`;
  }
};
__decorateClass([
  property({ type: Number })
], Pagination.prototype, "index", 2);
__decorateClass([
  property({ type: Number })
], Pagination.prototype, "current", 2);
__decorateClass([
  property({ type: Number })
], Pagination.prototype, "total", 2);
__decorateClass([
  property({ type: Function })
], Pagination.prototype, "onChange", 2);
__decorateClass([
  state()
], Pagination.prototype, "pages", 2);
Pagination = __decorateClass([
  customElement("ui5-pagination")
], Pagination);
export {
  Pagination
};
